package com.sun.xml.internal.ws.util;

import com.sun.xml.internal.ws.streaming.XMLReaderException;
import com.sun.xml.internal.ws.streaming.XMLStreamReaderException;
import javax.xml.stream.XMLStreamReader;
import java.io.InputStream;

public class FastInfosetUtil
{
    public FastInfosetUtil() {
    }
    
    public static XMLStreamReader createFIStreamReader(InputStream in) {
        if (FastInfosetReflection.fiStAXDocumentParser_new == null) {
            throw new XMLReaderException("fastinfoset.noImplementation", new Object[0]);
        }
        try {
            Object sdp = FastInfosetReflection.fiStAXDocumentParser_new.newInstance(new Object[0]);
            FastInfosetReflection.fiStAXDocumentParser_setStringInterning.invoke(sdp, new Object[] { Boolean.TRUE });
            FastInfosetReflection.fiStAXDocumentParser_setInputStream.invoke(sdp, new Object[] { in });
            return (XMLStreamReader)sdp;
        }
        catch (Exception e) {
            throw new XMLStreamReaderException(e);
        }
    }
}
